/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "GtkBookList.h"

#include <gtkmm.h>
#include <iostream>

using namespace std;

/* Unser Hauptfenster ist ein Gtk::Window. */
class MyWindow : public Gtk::Window
{
public:
  MyWindow();
  virtual ~MyWindow() {};
  
protected:
  GtkBookList booklist;
  void on_button_pressed(void);
};

MyWindow::MyWindow()
{
  Gtk::VBox   *vbox             = new Gtk::VBox;
  Gtk::ScrolledWindow *scrolled = new Gtk::ScrolledWindow;
  Gtk::Button *button           = new Gtk::Button(Gtk::Stock::DELETE);
  
  button->set_size_request(-1, 35);
  vbox->set_border_width(6);
  set_title("Testwindow");
  set_size_request(300, 300);
  
  scrolled->add(booklist);
  vbox->pack_start(*Gtk::manage(scrolled), TRUE, TRUE);
  vbox->pack_start(*Gtk::manage(button), FALSE, FALSE);
  add(*Gtk::manage(vbox));
  
  // Fill the list with data.
  Book* books[50];
  int i;
  for (i = 0; i < 40; i++) {
    books[i] = new Book;
    char title[100];
    snprintf(title, 99, "Book Number %i", i);
    books[i]->set_title(title);
    booklist.insert_book(books[i]);
  }
  
  button->signal_clicked().connect(
    sigc::mem_fun(*this, &MyWindow::on_button_pressed));
  
  show_all();
}

void MyWindow::on_button_pressed(void)
{
  cout << "MyWindow::on_button_pressed(): Called." << endl;
  booklist.remove_selected();
}


int main (int argc, char *argv[])
{
  Gtk::Main meingtk(argc, argv);
  MyWindow test;
  Gtk::Main::run(test);
  return 0;
}
